#include <bits/stdc++.h>
using namespace std;

int D, R, C;
const int DR[8] = { -1, 1,  0, 0, -1, -1,  1, 1 };
const int DC[8] = {  0, 0, -1, 1, -1,  1, -1, 1 };
vector< vector<int> > plan;

inline bool inside(int r, int c) { return (r >= 0) && (r < R) && (c >= 0) && (c < C); }

void go(int step, int r, int c, int dirs_used) {
    // mark
    plan[r][c] = step;
    for (int d=0; d<D; ++d) {
        int nr = r + DR[d], nc = c + DC[d];
        while (inside(nr,nc)) { 
            if (plan[nr][nc] == 0) plan[nr][nc] = -step;
            nr += DR[d];
            nc += DC[d];
        }
    }

    // check if done
    if (dirs_used == (1<<D)-1) {
        cout << R << " " << C << endl;
        for (int r=0; r<R; ++r) {
            for (int c=0; c<C; ++c) {
                if (plan[r][c] <= 0) cout << '#'; else cout << char('0'+plan[r][c]);
            }
            cout << endl;
        }
        exit(0);
    }

    // try next step
    for (int d=0; d<D; ++d) {
        int nr = r + DR[d], nc = c + DC[d];
        while (inside(nr,nc)) {
            if (plan[nr][nc] == -step) {
                go(step+1,nr,nc,dirs_used | 1<<d);
                plan[nr][nc] = -step;
            }
            nr += DR[d];
            nc += DC[d];
        }
    }

    // unmark
    plan[r][c] = 0;
    for (int d=0; d<D; ++d) {
        int nr = r + DR[d], nc = c + DC[d];
        while (inside(nr,nc)) { 
            if (plan[nr][nc] == -step) plan[nr][nc] = 0;
            nr += DR[d];
            nc += DC[d];
        }
    }
}


int main() {
    cin >> D;
    vector< pair<int,int> > dimensions;
    for (int r=1; r<=7; ++r) for (int c=r; c<=49; ++c) dimensions.push_back( {r,c} );
    sort( dimensions.begin(), dimensions.end(), [](const pair<int,int> &A, const pair<int,int> &B) -> bool { return A.first*A.second < B.first*B.second; } );
    for (const auto &rec : dimensions) {
        R = rec.first;
        C = rec.second;
        for (int sr=0; sr<(R+1)/2; ++sr) for (int sc=0; sc<(C+1)/2; ++sc) {
            plan.clear();
            plan.resize( R, vector<int>(C,0) );
            go(1,sr,sc,0);
        }
    }
}

